///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id: BodyParser.h 56 2004-10-31 23:10:45Z brian $
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

#ifndef _BodyParser_h
#define _BodyParser_h

#include "util.h"

class MessageHeaderList;
class AbstractMultiLineString;
class MailMessageList;

class BodyParser
{
public:
    ~BodyParser()
    {
    }

    OWNED MailMessageList *parseBody(const MessageHeaderList *headers,
                                     const AbstractMultiLineString *body_text);

private:
    int skipToBlank(const AbstractMultiLineString *lines,
                    int &offset);
    int skipToNonBlank(const AbstractMultiLineString *lines,
                       int &offset);
    void addPart(OWNED AbstractMultiLineString *lines);
    void addPartsForBoundary(const AbstractMultiLineString *lines,
                             const string &boundary);
    void parse();

private:
    const MessageHeaderList *m_headers;
    const AbstractMultiLineString *m_bodyText;
    NewPtr<MailMessageList> m_bodyParts;
};

#endif

